#!/usr/bin/perl

# cbradjusttime.pl v1.0 by k8gu (ethan@k8gu.com)
# 30 November 2010
# licensed under GPL, see LICENSE for details

if ((0+@ARGV) == 1) {
    $cbroffsethr = @ARGV[0];
    $cbroffsethr =~ s/\+//gs;
} else {
    $cbroffsethr = 0;
}

@daysmonth = (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);

while ($logline = <STDIN>) {
    chomp $logline;
    @daysmonth[1] = 28;

    @fields = split/\s+/,$logline;
    
    if (@fields[0] eq "QSO:") {
	$date = @fields[3];
	@dfields = split/-/,$date;
	$day = @dfields[2];
	$month = @dfields[1];
	$year = @dfields[0];

	$time = @fields[4];
	$newtime = $time + $cbroffsethr*100;

	if ($newtime >= 2400) {
	    $newtime = $newtime - 2400;
	    $day++;
	    if (($year % 4) == 0) {
		if (($year % 100) != 0) {
		    @daysmonth[1] = 29;
		    print "leap!\n";
		}
		if (($year % 400) == 0) {
    		    @daysmonth[1] = 29;
		    print "leap!\n";
		}
	    }
	    if ($day > @daysmonth[$month-1]) {
		$day = 1;
		$month++;
		if ($month > 12) {
		    $month = 1;
		    $year++;
		}
	    }
	    $newdate = sprintf("%04d-%02d-%02d",$year,$month,$day);
	    $logline =~ s/$date/$newdate/gs;
	}
	if ($newtime < 0) {
	    $newtime = $newtime + 2400;
	    $day--;
	    if ($day < 1) {
		$month--;
		if ($month < 1) {
		    $month = 12;
		    $year--;
		    if (($year % 4) == 0) {
			if (($year % 100) != 0) {
			    @daysmonth[1] = 29;
			    print "leap!\n";
			}
			if (($year % 400) == 0) {
			    @daysmonth[1] = 29;
			    print "leap!\n";
			}
		    }
		}
		$day =  @daysmonth[$month-1];
	    }
	    $newdate = sprintf("%04d-%02d-%02d",$year,$month,$day);
	    $logline =~ s/$date/$newdate/gs;
	}
	$newtime = sprintf("%04d",$newtime);
	$time = " " . $time . " ";
	$newtime = " " . $newtime . " ";
	$logline =~ s/$time/$newtime/gs;    
    }
    print "$logline\n";
}
